/* UDF example:  Get dealer price for each product. */
USE [AdventureWorks2012]
GO

SET STATISTICS IO ON;

SELECT
	p.*
FROM
	Production.Product p
WHERE
	dbo.ufnGetProductDealerPrice(p.ProductID, '2006-07-21') < 25;

SELECT
	p.*
FROM
	Production.Product p
	INNER JOIN [Production].[ProductListPriceHistory] plph
		ON p.ProductID = plph.ProductID
		AND plph.StartDate <= '2006-07-21'
		AND ISNULL(plph.EndDate, '9999-12-31') > '2006-07-21'
WHERE
	plph.ListPrice < 25 / 0.60			--Keep ListPrice SARGable:  divide by discount

/*
Notes to make:
- Execution plan covers up cost of function:  makes it seem like the function is cheaper!
- SET STATISTICS IO ON covers up cost of function
- To see the true cost of the function, use a trace or extended events
*/